<Query Kind="Program">
  <Namespace>System.Collections.Concurrent</Namespace>
</Query>

void Main() {
  // 1. 取得資料來源
  int[] numbers = [0, 1, 2, 3, 4, 5, 6];

  // 2. 使用查詢運算式 ,延後執行
  var numQuery =
    from num in numbers
  	where(num % 2) == 0
  	select num;

  // 3. 執行查詢 (避免呼叫 ToList(),ToArray()..等方法,避免非必要複製操作)
  foreach(int num in numQuery) {
    Console.WriteLine("{0,1} from Query Expression", num);//0246
  }

  // 2. 使用方法為基礎查詢(method-base query),延後執行
  var queries = numbers.Where(num => (num % 2) == 0)
    .Select(num => num);
	
  // 3. 執行查詢 (避免呼叫 ToList(),ToArray()..等方法,避免非必要複製操作)	
  foreach(int num in queries) {
    Console.WriteLine("{0,1} from Method Chain", num);//0246
  }

}